#pragma once

#include "Activation.h"
#include "Perception.h"
#include "Placement.h"
#include "Propulsion.h"

class WayPoint {
 public:
  float distance = 0;
};
class Trajectory {
 public:
  float* waypoints;
};

class Acceleration {
 public:
  float GetMagnitude() { return 0; };
};

class Roboid {
 public:
  Roboid();
  Roboid(Placement configuration[], unsigned int thingCount);

  Perception perception;
  Propulsion propulsion;
  Acceleration acceleration;

  Placement* configuration;
  unsigned int thingCount;

  void Update();

  bool Drive(float forwardDistance);
  void FollowTrajectory(Trajectory* Trajectory);

 public:
  float* waypoints = nullptr;
  unsigned int waypointIx = 0;
  unsigned int waypointCount = 0;
};